diff -uwr sourceold/scripts/jfwgame.cpp source/scripts/jfwgame.cpp
--- sourceold/scripts/jfwgame.cpp	2011-10-22 20:22:09.983398400 +0800
+++ source/scripts/jfwgame.cpp	2012-02-13 19:32:56.856843700 +0800
@@ -1030,6 +1030,7 @@
 void JFW_Flying_Infantry::Created(GameObject *obj)
 {
 	Toggle_Fly_Mode(obj);
+	Destroy_Script();
 }
 
 void JFW_Flying_Infantry_Custom::Custom(GameObject *obj,int type,int param,GameObject *sender)
@@ -2748,6 +2749,7 @@
 {
 	Commands->Create_2D_Sound(Get_Parameter("Sound"));
 	Send_Message(Get_Int_Parameter("Red"),Get_Int_Parameter("Green"),Get_Int_Parameter("Blue"),Get_Parameter("Message"));
+	Destroy_Script();
 }
 
 void JFW_Message_Send_Death_Team::Killed(GameObject *obj, GameObject *killer)
@@ -2755,6 +2757,7 @@
 	int team = Get_Int_Parameter("Player_Type");
 	Create_2D_Sound_Team(Get_Parameter("Sound"),team);
 	Send_Message_Team(team,Get_Int_Parameter("Red"),Get_Int_Parameter("Green"),Get_Int_Parameter("Blue"),Get_Parameter("Message"));
+	Destroy_Script();
 }
 
 void JFW_Message_Send_Custom::Custom(GameObject *obj,int type,int param,GameObject *sender)
@@ -2796,6 +2799,7 @@
 void JFW_Spy_Switch_Team::Created(GameObject *obj)
 {
 	Change_Team_2(obj,PTTEAM(Commands->Get_Player_Type(obj)));
+	Commands->Set_Is_Visible(obj,false);
 }
 
 void JFW_Spy_Switch_Team::Killed(GameObject *obj, GameObject *killer)
@@ -2857,6 +2861,46 @@
 	}
 }
 
+void JFW_Spy_Vehicle_Ignore_New::Created(GameObject *obj)
+{
+	spycount = 0;
+	nonspycount = 0;
+}
+
+void JFW_Spy_Vehicle_Ignore_New::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (type == CUSTOM_EVENT_VEHICLE_ENTERED)
+	{
+		if (!Is_Spy(sender))
+		{
+			nonspycount++;
+		}
+		else
+		{
+			spycount++;
+		}
+	}
+	if (type == CUSTOM_EVENT_VEHICLE_EXITED)
+	{
+		if (!Is_Spy(sender))
+		{
+			nonspycount--;
+		}
+		else
+		{
+			spycount--;
+		}
+	}
+	if ((spycount) && (!nonspycount))
+	{
+		Set_Vehicle_Is_Visible(obj,false);
+	}
+	else
+	{
+		Set_Vehicle_Is_Visible(obj,true);
+	}
+}
+
 void JFW_Message_Send_Zone_Player_Vehicle::Entered(GameObject *obj,GameObject *enterer)
 {
 	int team = Get_Int_Parameter("Player_Type");
@@ -3142,6 +3186,7 @@
 ScriptRegistrant<JFW_Message_Send_Custom_Team> JFW_Message_Send_Custom_Team_Registrant("JFW_Message_Send_Custom_Team","Player_Type:int,Display_Message:string,Red:int,Blue:int,Green:int,Sound:string,Message:int,Delete:int");
 ScriptRegistrant<JFW_Spy_Switch_Team> JFW_Spy_Switch_Team_Registrant("JFW_Spy_Switch_Team","");
 ScriptRegistrant<JFW_Spy_Vehicle_Ignore> JFW_Spy_Vehicle_Ignore_Registrant("JFW_Spy_Vehicle_Ignore","Spy_Script:string");
+ScriptRegistrant<JFW_Spy_Vehicle_Ignore_New> JFW_Spy_Vehicle_Ignore_New_Registrant("JFW_Spy_Vehicle_Ignore_New","");
 ScriptRegistrant<JFW_Message_Send_Zone_Player_Vehicle> JFW_Message_Send_Zone_Player_Vehicle_Registrant("JFW_Message_Send_Zone_Player_Vehicle","Player_Type:int,Message:string,Red:int,Blue:int,Green:int,Sound:string,Delete:int");
 ScriptRegistrant<JFW_Water_Level> JFW_Water_Level_Registrant("JFW_Water_Level","Message:int");
 ScriptRegistrant<JFW_Submarine> JFW_Submarine_Registrant("JFW_Submarine","Message:int,Submerge_Armor:string,Surface_Armor:string,Block_Weapon:int,Ping_Sound:string,Surface_Sound:string,Ping_Time:float,Surface_Z_Offset:float,Dive_Z_Offset:float,Powerup:string,Weapon:string");
diff -uwr sourceold/scripts/jfwgame.h source/scripts/jfwgame.h
--- sourceold/scripts/jfwgame.h	2011-10-14 22:27:32.040039000 +0800
+++ source/scripts/jfwgame.h	2012-02-13 18:26:32.682039000 +0800
@@ -388,6 +388,13 @@
 	int nonspycount;
 };
 
+class JFW_Spy_Vehicle_Ignore_New : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	int spycount;
+	int nonspycount;
+};
+
 class JFW_Message_Send_Zone_Player_Vehicle : public ScriptImpClass {
 	void Entered(GameObject *obj,GameObject *enterer);
 };
diff -uwr sourceold/scripts/jfwmisc.cpp source/scripts/jfwmisc.cpp
--- sourceold/scripts/jfwmisc.cpp	2011-11-22 15:22:13.707031200 +0800
+++ source/scripts/jfwmisc.cpp	2012-02-13 19:32:56.703523400 +0800
@@ -256,6 +256,7 @@
 	params.AttackActive = false;
 	params.AttackCheckBlocked = false;
 	Commands->Action_Goto(obj,params);
+	Destroy_Script();
 }
 
 void JFW_Follow_Waypath_Zone::Entered(GameObject *obj,GameObject *enterer)
@@ -436,6 +437,7 @@
 	char *anim = new char[(strlen(model) * 2) + 2];
 	sprintf(anim,"%s.%s",model,model);
 	Commands->Set_Animation(obj,anim,false,0,0,-1,false);
+	Destroy_Script();
 }
 
 void JFW_Play_Animation_Destroy_Object::Animation_Complete(GameObject *obj,const char *animation_name)
@@ -620,6 +622,7 @@
 	params.Set_Basic(this,100,2);
 	params.Set_Movement(Commands->Find_Object(Get_Int_Parameter("ID")),Get_Float_Parameter("Speed"),Get_Float_Parameter("Arrivedistance"));
 	Commands->Action_Goto(obj,params);
+	Destroy_Script();
 }
 
 void JFW_Scope::Created(GameObject *obj)
@@ -655,6 +658,7 @@
 void JFW_BHS_DLL::Created(GameObject *obj)
 {
 	Console_Output("TT.DLL is required for this map");
+	Destroy_Script();
 }
 
 void JFW_Screen_Fade_Custom_Timer::Custom(GameObject *obj,int type,int param,GameObject *sender)
@@ -738,6 +742,7 @@
 	{
 		Set_GDI_Soldier_Name(Get_Parameter("Character"));
 	}
+	Destroy_Script();
 }
 
 void JFW_Show_Info_Texture::Created(GameObject *obj)
@@ -757,16 +762,19 @@
 void JFW_Wireframe_Mode::Created(GameObject *obj)
 {
 	Set_Wireframe_Mode(Get_Int_Parameter("Mode"));
+	Destroy_Script();
 }
 
 void JFW_PT_Hide::Created(GameObject *obj)
 {
 	Hide_Preset_By_Name(Get_Int_Parameter("Player_Type"),Get_Parameter("Preset"),true);
+	Destroy_Script();
 }
 
 void JFW_PT_Hide_Death::Killed(GameObject *obj,GameObject *killer)
 {
 	Hide_Preset_By_Name(Get_Int_Parameter("Player_Type"),Get_Parameter("Preset"),true);
+	Destroy_Script();
 }
 
 void JFW_PT_Hide_Custom::Custom(GameObject *obj,int type,int param,GameObject *sender)
@@ -785,16 +793,19 @@
 void JFW_PT_Hide_Timer::Timer_Expired(GameObject *obj,int number)
 {
 	Hide_Preset_By_Name(Get_Int_Parameter("Player_Type"),Get_Parameter("Preset"),true);
+	Destroy_Script();
 }
 
 void JFW_PT_Show::Created(GameObject *obj)
 {
 	Hide_Preset_By_Name(Get_Int_Parameter("Player_Type"),Get_Parameter("Preset"),false);
+	Destroy_Script();
 }
 
 void JFW_PT_Show_Death::Killed(GameObject *obj,GameObject *killer)
 {
 	Hide_Preset_By_Name(Get_Int_Parameter("Player_Type"),Get_Parameter("Preset"),false);
+	Destroy_Script();
 }
 
 void JFW_PT_Show_Custom::Custom(GameObject *obj,int type,int param,GameObject *sender)
@@ -813,11 +824,13 @@
 void JFW_PT_Show_Timer::Timer_Expired(GameObject *obj,int number)
 {
 	Hide_Preset_By_Name(Get_Int_Parameter("Player_Type"),Get_Parameter("Preset"),false);
+	Destroy_Script();
 }
 
 void JFW_Change_Radar_Map::Created(GameObject *obj)
 {
 	Change_Radar_Map(Get_Float_Parameter("Scale"),Get_Float_Parameter("OffsetX"),Get_Float_Parameter("OffsetY"),Get_Parameter("Texture"));
+	Destroy_Script();
 }
 
 void JFW_Goto_Player_Timer::Created(GameObject *obj)
@@ -906,6 +919,7 @@
 		{
 			Enable_Base_Radar(Get_Object_Type(obj),false);
 		}
+	Destroy_Script();
 }
 
 void JFW_Game_Hint_Soldier::Created(GameObject *obj)
@@ -979,6 +993,7 @@
 void JFW_Moon_Is_Earth::Created(GameObject *obj)
 {
 	Set_Moon_Is_Earth(true);
+	Destroy_Script();
 }
 
 void JFW_Points_Custom::Custom(GameObject *obj,int type,int param,GameObject *sender)
@@ -1410,6 +1425,7 @@
 void JFW_Radar_Disable_Death::Killed(GameObject *obj,GameObject *killer)
 {
 	Enable_Base_Radar(Get_Object_Type(obj),false);
+	Destroy_Script();
 }
 
 void JFW_Cyborg_Reaper::Created(GameObject *obj)
@@ -1463,6 +1479,7 @@
 void JFW_Death_Send_Custom_Self::Killed(GameObject *obj,GameObject *killer)
 {
 	Commands->Send_Custom_Event(obj,obj,Get_Int_Parameter("Message"),0,0);
+	Destroy_Script();
 }
 
 void JFW_Hunter_Seeker::Created(GameObject *obj)
diff -uwr sourceold/scripts/jfwpoke.cpp source/scripts/jfwpoke.cpp
--- sourceold/scripts/jfwpoke.cpp	2011-10-11 23:05:08.540039000 +0800
+++ source/scripts/jfwpoke.cpp	2012-02-13 19:32:56.450593700 +0800
@@ -84,6 +84,7 @@
 void JFW_Pokeable_Item::Created(GameObject *obj)
 {
 	Commands->Enable_HUD_Pokable_Indicator(obj,1);
+	Destroy_Script();
 }
 
 void JFW_Preset_Buy_Poke::Poked(GameObject *obj,GameObject *poker)
diff -uwr sourceold/scripts/jfwpow.cpp source/scripts/jfwpow.cpp
--- sourceold/scripts/jfwpow.cpp	2011-12-01 12:52:17.931640600 +0800
+++ source/scripts/jfwpow.cpp	2012-02-13 19:12:33.689851500 +0800
@@ -101,6 +101,7 @@
 void JFW_Give_Powerup_Create::Created(GameObject *obj)
 {
 	Commands->Give_PowerUp(obj,Get_Parameter("Powerup"),false);
+	Destroy_Script();
 }
 
 void JFW_Change_Character_Powerup::Custom(GameObject *obj,int type,int param,GameObject *sender)
@@ -129,6 +130,7 @@
 void JFW_Clear_Money_Create::Created(GameObject *obj)
 {
 	Commands->Give_Money(obj,-Commands->Get_Money(obj),false);
+	Destroy_Script();
 }
 
 void JFW_Give_Money::Custom(GameObject *obj,int type,int param,GameObject *sender)
diff -uwr sourceold/scripts/jfwscr.cpp source/scripts/jfwscr.cpp
--- sourceold/scripts/jfwscr.cpp	2011-10-11 23:05:07.345703100 +0800
+++ source/scripts/jfwscr.cpp	2012-02-13 19:12:33.589265600 +0800
@@ -246,6 +246,7 @@
 void JFW_Remove_Script_Death::Killed(GameObject *obj,GameObject *killer)
 {
 	Remove_Script(obj,Get_Parameter("Script"));
+	Destroy_Script();
 }
 
 void JFW_Attach_Script_Custom::Custom(GameObject *obj,int type,int param,GameObject *sender)
@@ -376,6 +377,7 @@
 	}
 	Attach_Script_Preset(script,params,Get_Parameter("Preset"),Get_Int_Parameter("Player_Type"));
 	delete[] params;
+	Destroy_Script();
 }
 
 void JFW_Attach_Script_Building_Startup::Created(GameObject *obj)
@@ -398,6 +400,7 @@
 	}
 	Attach_Script_Building(script,params,Get_Int_Parameter("Player_Type"));
 	delete[] params;
+	Destroy_Script();
 }
 
 void JFW_Attach_Script_Type_Startup::Created(GameObject *obj)
@@ -420,6 +423,7 @@
 	}
 	Attach_Script_Type(script,params,Get_Int_Parameter("Type"),Get_Int_Parameter("Player_Type"));
 	delete[] params;
+	Destroy_Script();
 }
 
 void JFW_Attach_Script_Collector::Custom(GameObject *obj,int type,int param,GameObject *sender)
diff -uwr sourceold/scripts/jfwsnd.cpp source/scripts/jfwsnd.cpp
--- sourceold/scripts/jfwsnd.cpp	2011-10-11 23:05:06.098632800 +0800
+++ source/scripts/jfwsnd.cpp	2012-02-13 19:12:33.200593700 +0800
@@ -344,6 +344,7 @@
 void JFW_2D_Sound_Startup::Created(GameObject *obj)
 {
 	Commands->Create_2D_Sound(Get_Parameter("Sound"));
+	Destroy_Script();
 }
 
 void JFW_Time_Remaining_Sounds::Created(GameObject *obj)
@@ -406,6 +407,7 @@
 void JFW_2D_Sound_Death_Team::Killed(GameObject *obj,GameObject *killer)
 {
 	Create_2D_Sound_Team(Get_Parameter("Sound"),Get_Object_Type(obj));
+	Destroy_Script();
 }
 
 void JFW_Vehicle_Full_Sound::Created(GameObject *obj)
@@ -482,6 +484,7 @@
 	{
 		Commands->Create_2D_Sound(Get_Parameter("Sound"));
 	}
+	Destroy_Script();
 }
 
 void JFW_C4_Sound_2::Created(GameObject *obj)
@@ -501,6 +504,7 @@
 	{
 		Commands->Create_2D_Sound(Get_Parameter("Sound"));
 	}
+	Destroy_Script();
 }
 
 ScriptRegistrant<JFW_Set_Background_Music_On_Custom> JFW_Set_Background_Music_On_Custom_Registrant("JFW_Set_Background_Music_On_Custom","Message:int,Music:string");
diff -uwr sourceold/scripts/jfwveh.cpp source/scripts/jfwveh.cpp
--- sourceold/scripts/jfwveh.cpp	2011-12-01 12:47:58.142578100 +0800
+++ source/scripts/jfwveh.cpp	2012-02-23 12:06:21.760742100 +0800
@@ -100,6 +100,7 @@
 	params.Set_Basic(this,100,777);
 	params.Set_Movement(Commands->Get_A_Star(Commands->Get_Position(obj)),Get_Float_Parameter("Speed"),Get_Float_Parameter("Arrive_Distance"));
 	Commands->Action_Goto(obj,params);
+	Destroy_Script();
 }
 
 void JFW_Vechicle_Animation::Timer_Expired(GameObject *obj,int number)
@@ -144,6 +145,7 @@
 {
 	if (!_stricmp(animation_name,Get_Parameter("Animation")))
 	{
+		obj->As_PhysicalGameObj()->Clear_Animation();
 		const char *subobject = Get_Parameter("Subobject");
 		if (!_stricmp(subobject,"0"))
 		{
@@ -180,7 +182,7 @@
 	if (type == CUSTOM_EVENT_VEHICLE_ENTERED)
 	{
 		Vector3 position = Commands->Get_Bone_Position(obj,Get_Parameter("BoneName"));
-		GameObject *object = Commands->Create_Object("Generic_Cinematic",position);
+		GameObject *object = Commands->Create_Object("Invisible_Object",position);
 		Commands->Attach_To_Object_Bone(object,obj,Get_Parameter("BoneName"));
 		Commands->Set_Model(object,Get_Parameter("ModelName"));
 		modelid = Commands->Get_ID(object);
@@ -228,7 +230,7 @@
 		if (!modelid1)
 		{
 			Vector3 position = Commands->Get_Bone_Position(obj,Get_Parameter("BoneName1"));
-			GameObject *object = Commands->Create_Object("Generic_Cinematic",position);
+			GameObject *object = Commands->Create_Object("Invisible_Object",position);
 			Commands->Attach_To_Object_Bone(object,obj,Get_Parameter("BoneName1"));
 			Commands->Set_Model(object,Get_Parameter("ModelName1"));
 			modelid1 = Commands->Get_ID(object);
@@ -249,7 +251,7 @@
 			if (!modelid2)
 			{
 				Vector3 position = Commands->Get_Bone_Position(obj,Get_Parameter("BoneName2"));
-				GameObject *object = Commands->Create_Object("Generic_Cinematic",position);
+				GameObject *object = Commands->Create_Object("Invisible_Object",position);
 				Commands->Attach_To_Object_Bone(object,obj,Get_Parameter("BoneName2"));
 				Commands->Set_Model(object,Get_Parameter("ModelName2"));
 				modelid2 = Commands->Get_ID(object);
@@ -321,7 +323,7 @@
 		//End Code added by NeoSaber
 
 		Vector3 position = Commands->Get_Bone_Position(obj,Get_Parameter("BoneName"));
-		GameObject *object = Commands->Create_Object("Generic_Cinematic",position);
+		GameObject *object = Commands->Create_Object("Invisible_Object",position);
 		Commands->Attach_To_Object_Bone(object,obj,Get_Parameter("BoneName"));
 		Commands->Send_Custom_Event(obj,sender,Get_Int_Parameter("Message"),Commands->Get_ID(object),0);
 		modelid = Commands->Get_ID(object);
@@ -358,7 +360,7 @@
 		if (!modelid1)
 		{
 			Vector3 position = Commands->Get_Bone_Position(obj,Get_Parameter("BoneName1"));
-			GameObject *object = Commands->Create_Object("Generic_Cinematic",position);
+			GameObject *object = Commands->Create_Object("Invisible_Object",position);
 			Commands->Attach_To_Object_Bone(object,obj,Get_Parameter("BoneName1"));
 			Commands->Send_Custom_Event(obj,sender,Get_Int_Parameter("Message1"),Commands->Get_ID(object),0);
 			modelid1 = Commands->Get_ID(object);
@@ -368,7 +370,7 @@
 			if (!modelid2)
 			{
 				Vector3 position = Commands->Get_Bone_Position(obj,Get_Parameter("BoneName2"));
-				GameObject *object = Commands->Create_Object("Generic_Cinematic",position);
+				GameObject *object = Commands->Create_Object("Invisible_Object",position);
 				Commands->Attach_To_Object_Bone(object,obj,Get_Parameter("BoneName2"));
 				Commands->Send_Custom_Event(obj,sender,Get_Int_Parameter("Message2"),Commands->Get_ID(object),0);
 				modelid2 = Commands->Get_ID(object);
@@ -506,9 +508,10 @@
 		float firstframe = Get_Float_Parameter("FirstFrame");
 		if (firstframe == -1)
 		{
-			firstframe = Get_Animation_Frame(Commands->Find_Object(ID));
+			firstframe = Get_Animation_Frame(obj);
 		}
-		Commands->Set_Animation(Commands->Find_Object(ID),Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
+		obj->As_PhysicalGameObj()->Clear_Animation();
+		Commands->Set_Animation(obj,Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
 	}
 }
 
@@ -598,6 +601,7 @@
 		{
 			firstframe = Get_Animation_Frame(obj);
 		}
+		obj->As_PhysicalGameObj()->Clear_Animation();
 		Commands->Set_Animation(obj,Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
 	}
 }
@@ -830,6 +834,7 @@
 		{
 			firstframe = Get_Animation_Frame(obj);
 		}
+		obj->As_PhysicalGameObj()->Clear_Animation();
 		Commands->Set_Animation(obj,Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
 	}
 }
diff -uwr sourceold/scripts/jfwws.cpp source/scripts/jfwws.cpp
--- sourceold/scripts/jfwws.cpp	2011-11-07 20:33:46.811523400 +0800
+++ source/scripts/jfwws.cpp	2012-02-13 19:32:56.805085900 +0800
@@ -18,6 +18,7 @@
 {
 	Vector3 pos = Commands->Get_Position(obj);
 	Commands->Shake_Camera(pos,(float)25.0,(float)0.1,(float)4.0);
+	Destroy_Script();
 }
 
 void JFW_Viceroid_Innate::Created(GameObject *obj)
@@ -34,6 +35,7 @@
 void JFW_No_Innate::Created(GameObject *obj)
 {
 	Commands->Innate_Disable(obj);
+	Destroy_Script();
 }
 
 void JFW_Credit_Trickle::Created(GameObject *obj)
@@ -94,6 +96,7 @@
 void JFW_Disable_Transition::Created(GameObject *obj)
 {
 	Commands->Enable_Vehicle_Transitions(obj,false);
+	Destroy_Script();
 }
 
 void JFW_Permanent_No_Falling_Damage::Created(GameObject *obj)
@@ -133,6 +136,7 @@
 void JFW_GrantPowerup_Created::Created(GameObject *obj)
 {
 	Commands->Give_PowerUp(obj,Get_Parameter("WeaponDef"),false);
+	Destroy_Script();
 }
 
 void JFW_CnC_Crate::Custom(GameObject *obj,int type,int param,GameObject *sender)
@@ -193,11 +197,13 @@
 void JFW_Disable_Physical_Collision::Created(GameObject *obj)
 {
 	Commands->Disable_Physical_Collisions(obj);
+	Destroy_Script();
 }
 
 void JFW_Enable_Physical_Collision::Created(GameObject *obj)
 {
 	Commands->Enable_Collisions(obj);
+	Destroy_Script();
 }
 
 void JFW_DestroyedStateObject::Destroyed(GameObject *obj)
@@ -331,12 +337,13 @@
 void JFW_Send_Object_ID::Created(GameObject *obj)
 {
 	int recieverid = Get_Int_Parameter("Receiver_ID");
-	int param = Get_Int_Parameter("Receiver_ID");
-	float delay = Get_Float_Parameter("Receiver_ID");
+	int param = Get_Int_Parameter("Param");
+	float delay = Get_Float_Parameter("Delay");
 	if (Commands->Find_Object(recieverid))
 	{
 		Commands->Send_Custom_Event(obj,Commands->Find_Object(recieverid),9035,param,delay);
 	}
+	Destroy_Script();
 }
 
 void JFW_Ion_Cannon_Sound::Created(GameObject *obj)
@@ -351,6 +358,7 @@
 	{
 		Commands->Create_Sound("Ion_Cannon_Fire",v,obj);
 	}
+	Destroy_Script();
 }
 
 void JFW_NukeStrike_Anim::Created(GameObject *obj)
@@ -550,6 +558,7 @@
 		Commands->Send_Custom_Event(obj,object,9026,1,0);
 		Commands->Send_Custom_Event(obj,object,9027,1,0);
 	}
+	Destroy_Script();
 }
 
 void JFW_BuildingStateSoundController::Custom(GameObject *obj,int type,int param,GameObject *sender)
@@ -661,6 +670,7 @@
 void JFW_InnateIsStationary::Created(GameObject *obj)
 {
 	Commands->Set_Innate_Is_Stationary(obj,true);
+	Destroy_Script();
 }
 
 void JFW_Generic_Conv::Created(GameObject *obj)
@@ -669,11 +679,13 @@
 	Commands->Join_Conversation(obj,convid,true,true,true);
 	Commands->Start_Conversation(convid,100000);
 	Commands->Monitor_Conversation(obj,convid);
+	Destroy_Script();
 }
 
 void JFW_Disable_Hibernation::Created(GameObject *obj)
 {
 	Commands->Enable_Hibernation(obj,0);
+	Destroy_Script();
 }
 
 ScriptRegistrant<JFW_Building_Explode_No_Damage> JFW_Building_Explode_No_Damage_Registrant("JFW_Building_Explode_No_Damage","");
